Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing
Class AbstractAction

    java.lang.Object
      |
      +--javax.swing.AbstractAction

Direct Known Subclasses:
  BasicDesktopPaneUI.CloseAction, BasicDesktopPaneUI.MaximizeAction, BasicDesktopPaneUI.MinimizeAction, BasicDesktopPaneUI.NavigateAction, BasicFileChooserUI.ApproveSelectionAction, BasicFileChooserUI.CancelSelectionAction, BasicFileChooserUI.ChangeToParentDirectoryAction, BasicFileChooserUI.GoHomeAction, BasicFileChooserUI.NewFolderAction, BasicFileChooserUI.UpdateAction, BasicInternalFrameTitlePane.CloseAction, BasicInternalFrameTitlePane.IconifyAction, BasicInternalFrameTitlePane.MaximizeAction, BasicInternalFrameTitlePane.MoveAction, BasicInternalFrameTitlePane.RestoreAction, BasicInternalFrameTitlePane.SizeAction, BasicSliderUI.ActionScroller, BasicTreeUI.TreeCancelEditingAction, BasicTreeUI.TreeHomeAction, BasicTreeUI.TreeIncrementAction, BasicTreeUI.TreePageAction, BasicTreeUI.TreeToggleAction, BasicTreeUI.TreeTraverseAction, MetalFileChooserUI.DirectoryComboBoxAction, TextAction

public abstract class AbstractAction
extends java.lang.Object
implements Action, java.lang.Cloneable, java.io.Serializable

This class provides default implementations for the JFC Action interface. Standard behaviors like the get and set methods for Action object properties (icon, text, and enabled) are defined here. The developer need only subclass this abstract class and define the `actionPerformed` method.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  `Action`, Serialized Form

Field Summary
`protected SwingPropertyChangeSupport` | `changeSupport`
`protected boolean` | `enabled`

Constructor Summary
`AbstractAction()` Defines an Action object with a default description string and default icon.
`AbstractAction(java.lang.String name)` Defines an Action object with the specified description string and a default icon.
`AbstractAction(java.lang.String name, Icon icon)` Defines an Action object with the specified description string and a the specified icon.

Method Summary
`void` | `addPropertyChangeListener(java.beans.PropertyChangeListener listener)` Add a PropertyChangeListener to the listener list.
`protected java.lang.Object` | `clone()` Clone the abstract action.
`protected void` | `firePropertyChange(java.lang.String propertyName, java.lang.Object oldValue, java.lang.Object newValue)` Support for reporting bound property changes.
`java.lang.Object` | `getValue(java.lang.String key)` Gets the Object associated with the specified key.
`boolean` | `isEnabled()` Returns true if the action is enabled.
`void` | `putValue(java.lang.String key, java.lang.Object newValue)` Sets the Value associated with the specified key.
`void` | `removePropertyChangeListener(java.beans.PropertyChangeListener listener)` Remove a PropertyChangeListener from the listener list.
`void` | `setEnabled(boolean newValue)` Enables or disables the action.

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### enabled

    protected boolean enabled

### changeSupport

    protected SwingPropertyChangeSupport changeSupport

Constructor Detail

### AbstractAction

    public AbstractAction()

  Defines an Action object with a default description string and default icon.

### AbstractAction

    public AbstractAction(java.lang.String name)

  Defines an Action object with the specified description string and a default icon.

### AbstractAction

    public AbstractAction(java.lang.String name,
                          Icon icon)

  Defines an Action object with the specified description string and a the specified icon.

Method Detail

### getValue

    public java.lang.Object getValue(java.lang.String key)

  Gets the Object associated with the specified key.
  Specified by:
    getValue in interface Action
  Returns:
    the Object stored with this key
  See Also:
    `Action.getValue(java.lang.String)`

### putValue

    public void putValue(java.lang.String key,
                         java.lang.Object newValue)

  Sets the Value associated with the specified key.
  Specified by:
    putValue in interface Action
  Parameters:
    `key` - the String that identifies the stored object
    `newValue` - the Object to store using this key
  See Also:
    `Action.putValue(java.lang.String, java.lang.Object)`

### isEnabled

    public boolean isEnabled()

  Returns true if the action is enabled.
  Specified by:
    isEnabled in interface Action
  Returns:
    true if the action is enabled
  See Also:
    `Action.isEnabled()`

### setEnabled

    public void setEnabled(boolean newValue)

  Enables or disables the action.
  Specified by:
    setEnabled in interface Action
  Parameters:
    `newValue` - true to enable the action, false to disable it
  See Also:
    `Action.setEnabled(boolean)`

### firePropertyChange

    protected void firePropertyChange(java.lang.String propertyName,
                                      java.lang.Object oldValue,
                                      java.lang.Object newValue)

  Support for reporting bound property changes. This method can be called when a bound property has changed and it will send the appropriate PropertyChangeEvent to any registered PropertyChangeListeners.

### addPropertyChangeListener

    public void addPropertyChangeListener(java.beans.PropertyChangeListener listener)

  Add a PropertyChangeListener to the listener list. The listener is registered for all properties.

  A PropertyChangeEvent will get fired in response to setting a bound property, e.g. setFont, setBackground, or setForeground. Note that if the current component is inheriting its foreground, background, or font from its container, then no event will be fired in response to a change in the inherited property.

  Specified by:
    addPropertyChangeListener in interface Action
  Parameters:
    `listener` - The PropertyChangeListener to be added
  See Also:
    `Action.addPropertyChangeListener(java.beans.PropertyChangeListener)`

### removePropertyChangeListener

    public void removePropertyChangeListener(java.beans.PropertyChangeListener listener)

  Remove a PropertyChangeListener from the listener list. This removes a PropertyChangeListener that was registered for all properties.
  Specified by:
    removePropertyChangeListener in interface Action
  Parameters:
    `listener` - The PropertyChangeListener to be removed
  See Also:
    `Action.removePropertyChangeListener(java.beans.PropertyChangeListener)`

### clone

    protected java.lang.Object clone()
                              throws java.lang.CloneNotSupportedException

  Clone the abstract action. This gives the clone its own copy of the key/value list, which is not handled for you by Object.clone()
  Overrides:
    clone in class java.lang.Object

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.